<template>
	<f7-page name="freebiesform" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Barang Loak</f7-nav-title>
            <f7-nav-title-large>{{ formType }} Barang</f7-nav-title-large>
		</f7-navbar>
		<f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="gradient-cyan">
			<h3 class="no-margin">Penting!</h3>
			<p>Barang loak merupakan barang bekas layak pakai atau masih mempunyai nilai jual yang dapat anda sumbangkan kepada siapapun.</p>
		</f7-block>
		<f7-block>
			<div class="uploader margin-medium-bottom">
                <div v-if="freebie && freebie.medias && freebie.medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in freebie.medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.medium})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Foto</span>
                        </a>
                    </div>
                </div>
                <div v-else-if="medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.original})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Foto</span>
                        </a>
                    </div>
                </div>
                <div v-else class="uploader-item">
                    <a class="text-align-center add-image" href="#" @click="handleUpload">
                        <f7-icon f7="add" size="50"></f7-icon>
                        <span class="display-block">Foto</span>
                    </a>
                </div>
            </div>
		</f7-block>
		<f7-list no-hairlines class="no-margin">							
			<f7-list-input
				ref="title"
				label="Judul"
				placeholder="Ketik judul barang"
				maxlength="255"
				clear-button
				:value="freebiesForm.title"
				@input="freebiesForm.title = $event.target.value">
			</f7-list-input>
			<f7-list-input
				ref="description"
				type="textarea"
				label="Deskripsi"
				placeholder="Ketik deskripsi disini"
				resizable					
				:value="freebiesForm.description"
				@input="freebiesForm.description = $event.target.value">
			</f7-list-input>
			<f7-list-item>
				<div class="item-title">Lokasi pengambilan</div>
			</f7-list-item>
			<li>
                <div class="item-content item-input item-input-with-value">
                    <div class="item-inner no-padding-right">
                        <div class="item-input-wrap">
							<GmapMap 
								id="map"
								ref="mapRef"
								:options="{
									zoomControl: true,
									mapTypeControl: false,
									scaleControl: false,
									streetViewControl: false,
									rotateControl: false,
									fullscreenControl: true,
									disableDefaultUi: false,
									scrollwheel: false
								}"
								:zoom="map.zoom"
								:center="map.center"
								:draggable="true"
								@center_changed="handleCenterChanged($event)">
							</GmapMap>
						</div>
                    </div>
                </div>				
			</li>
            <f7-list-item>
				<div class="item-title">Setuju dengan ketentuan RingSatu</div>
				<f7-toggle 
					color="blue"
					:value="1"
					:checked="freebiesForm.tac"
					@toggleChange="handleAgreed($event)"></f7-toggle>
			</f7-list-item>			
		</f7-list>
        <p v-if="freebiesForm.tac == true" style="text-align: justify;">Dengan ini saya setuju untuk tidak mempublikasikan freebiermasi yang bersifat SARA atau hinaan terhadap pihak-pihak tertentu. Jika terjadi pelanggaran pada freebiermasi yang saya buat, RingSatu berhak untuk menghapus freebiermasi yang saya publikasikan tanpa pemberitahuan sebelumnya.</p>
		<br>
		<f7-row>
			<f7-col>
				<f7-button @click="doSubmit($event, 'draft')" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button text-align-left" large>Simpan</f7-button>
			</f7-col>
			<f7-col>
				<f7-button @click="doSubmit($event, 'publish')" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>Publikasikan</f7-button>
			</f7-col>
		</f7-row>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { gmapApi } from 'vue2-google-maps';
import { parseError, dateFormat } from '../js/utils';
import { setTimeout } from 'timers';
export default {
	name: 'FreebiesForm',
	data(){
		return{
			formType: 'Tambah',
			map: {
				zoom: 14,
				center: {
					lat: -2.9760735,
					lng: 104.77543070000002
				}
			},
			freebiesForm: {
				id: null,
				title: '',
				description: '',
				latitude: null,
				longitude: null,
				user: null,
                medias: [],
                tac: false
			},
			medias: []
		}
	},
	computed: {
		...mapGetters('auth', ['user']),
		...mapGetters('freebies', [
			'freebies',
			'freebie',
			'pagination'
		]),
		currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
	},
	methods: {
		dateFormat,
		google: gmapApi,
		onPageBeforeIn(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);
            
			if(self.$f7route.params && self.$f7route.params.id){
				self.formType = 'Ubah';
				self.freebiesForm.id = self.$f7route.params.id;
			
				app.preloader.show('green');

				self.$store.dispatch('freebies/viewFreebie', {
					id: self.freebiesForm.id,
					only: 'id,title,slug,description,latitude,longitude,created,updated,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,author.id,author.profile,author.profile.fullname,author.profile.initial,author.profile.media'
				}).then((response) => {
					
					self.freebiesForm.title = self.freebie.title;
                    self.freebiesForm.description = self.freebie.description;
                    
					if(self.freebie.latitude && self.freebie.longitude){
						self.freebiesForm.latitude = self.freebie.latitude;
						self.freebiesForm.longitude = self.freebie.longitude;

						self.map.zoom = 18;
						self.map.center.lat = self.freebie.latitude;
						self.map.center.lng = self.freebie.longitude;
                    }

					app.preloader.hide();
				});
			}

			if(self.currentLocation != null){
				self.map.zoom = 18;
				self.map.center.lat = self.currentLocation.latitude;
                self.map.center.lng = self.currentLocation.longitude;
                self.freebiesForm.latitude = self.currentLocation.latitude;
                self.freebiesForm.longitude = self.currentLocation.longitude;
			}

			self.setCenterMarker();

		},
		onPageBeforeOut(page){
			const self = this;
			
			if(page.detail.name == 'freebiesform'){
				self.freebiesForm = {
					id: null,
					title: '',
					description: '',
					latitude: null,
					longitude: null,
					status: 'draft',
					medias: []
				},
				self.medias = [];
				self.formType = 'Tambah';
			}
        },
        handleAgreed(value){
            const self = this;
            self.freebiesForm.tac = value;
        },
		setCenterMarker(){
			const self = this;
			const $$ = self.$$;

			setTimeout(() => {
				self.$refs.mapRef.$mapPromise.then((map) => {
					$$('<div/>').addClass('centerMarker').appendTo(map.getDiv());
				});
			}, 100);
		},
		handleCenterChanged(e){
			const self = this;
			setTimeout(() => {
				self.freebiesForm.latitude = e.lat();
				self.freebiesForm.longitude = e.lng();
			}, 3000);
		},
		doSubmit(e, status){
			const self = this;
            const app = self.$f7;
            
            if(self.freebiesForm.title.trim().length == 0){
				app.dialog.alert('Judul barang wajib diisi', 'RingSatu');
				return false;
			}else if(/^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/.test(self.freebiesForm.title) == false){
				app.dialog.alert('Judul barang hanya boleh diisi dengan dengan huruf, angka, tanda minus, tanda kurung tanda plus, garis miring, titik, koma dan spasi.', 'RingSatu');
				return false;
			}else if(self.freebiesForm.description.trim().length == 0){
				app.dialog.alert('Deskripsi wajib diisi', 'RingSatu');
				return false;
			}else if(self.freebiesForm.latitude == null || self.freebiesForm.longitude == null){
				app.dialog.alert('Silahkan tentukan lokasi pengambilan', 'RingSatu');
				return false;
			}else if(self.freebiesForm.tac == false){
                app.dialog.alert('Anda harus setuju dengan syarat dan ketentuan RingSatu', 'RingSatu');
				return false;
            }

			app.preloader.show('green');

			let action = '';
			let params = {};

			if(self.formType == 'Ubah'){
				params.id = self.$f7route.params.id;
				action = 'freebies/editFreebie';
			}else{
				action = 'freebies/createFreebie';
			}

            params.status = status;
			params.title = self.freebiesForm.title;
			params.description = self.freebiesForm.description;
			params.latitude = self.freebiesForm.latitude;
			params.longitude = self.freebiesForm.longitude;
			params.medias = self.freebiesForm.medias;
			params.only = 'id,title,slug,description,latitude,longitude,created,updated,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,author.id,author.profile,author.profile.fullname,author.profile.initial,author.profile.media'

			self.$store.dispatch(action, params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
			});
		},
		handleMediaDelete(e, imageId){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.dialog.confirm('Anda akan menghapus media ini. File tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Hapus File', function(){
				app.preloader.show('green');

				if(self.formType == 'Ubah'){
					self.$store.dispatch('media/deleteMedia', {
						id: parseInt(imageId),
						endpoint: 'freebies'
					}).then((response) => {
						$$('#image-'+imageId).remove();
						app.preloader.hide();
					});
				}else{
					self.$store.dispatch('media/deleteTmpMedia', {
						id: parseInt(imageId)
					}).then((response) => {
						$$('#image-'+imageId).remove();
						app.preloader.hide();
					});
				}
			})
		},
		handleUpload(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
			const $el = self.$el;
		
			var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {

									bannerImagePath = bannerImagePath.replace(/\s/g,'%20');

                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/freebies/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);
                                            
                                            if(self.formType == 'Ubah'){
                                                self.freebie.medias.push(response.data.media);
                                            }else{
                                                self.freebiesForm.medias.push(response.data.media.id);
                                                self.medias.push(response.data.media);
                                            }
                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {

									bannerImagePath = bannerImagePath.replace(/\s/g,'%20');

                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/freebies/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

                                        if(self.formType == 'Ubah'){
                                            self.freebie.medias.push(response.data.media);
                                        }else{
                                            self.freebiesForm.medias.push(response.data.media.id);
                                            self.medias.push(response.data.media);
                                        }

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
		}
	},

}
</script>
